--------------------------------------------
-- FILE        : Div100M.vhd
-- DESCRIPTION : divide by 100 million
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


library UNISIM;
use UNISIM.VComponents.all;

ENTITY Div100M is
  PORT(
    CLK    : IN  std_logic;
    CLKDIV : OUT std_logic
	);
END Div100M;

ARCHITECTURE ArchDiv100M OF Div100M IS


  component divider_srl is
    PORT(
      CLK    : IN  std_logic;
      CE_IN  : IN  std_logic;
  	  DIV    : IN  std_logic_vector(4 downto 0);
      CE_OUT : OUT std_logic
  	);
  end component divider_srl;
  
  signal   div    : std_logic_vector(5 downto 0);
  constant DIV_25 : std_logic_vector(4 downto 0) := "11000";
  constant DIV_20 : std_logic_vector(4 downto 0) := "10011";



BEGIN

  -- divide by 25
  u0 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => '1',
    DIV    => DIV_25,
    CE_OUT => div(0)
	);
	
	
  -- divide by 25
  u1 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => div(0),
    DIV    => DIV_25,
    CE_OUT => div(1)
	);

	
  -- divide by 20
  u2 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => div(1),
    DIV    => DIV_20,
    CE_OUT => div(2)
	);

	
  -- divide by 20
  u3 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => div(2),
    DIV    => DIV_20,
    CE_OUT => div(3)
	);

	
  -- divide by 20
  u4 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => div(3),
    DIV    => DIV_20,
    CE_OUT => div(4)
	);

	
  -- divide by 20
  u5 : divider_srl
  port map (
    CLK    => CLK,
    CE_IN  => div(4),
    DIV    => DIV_20,
    CE_OUT => div(5)
	);


	
  CLKDIV <= div(5);

  
  
END ArchDiv100M;
--------------------------------------------
-- END OF FILE : Div100M.vhd
--------------------------------------------

