--------------------------------------------
-- FILE        : arch_divider_srl.vhd
-- DESCRIPTION : instantiates an SRL32 with AND gate
--------------------------------------------

library IEEE;
use IEEE.STD_LOGIC_1164.ALL;


library UNISIM;
use UNISIM.VComponents.all;


ENTITY divider_srl is
  PORT(
    CLK    : IN  std_logic;
    CE_IN  : IN  std_logic;
    DIV    : IN  std_logic_vector(4 downto 0);
    CE_OUT : OUT std_logic  
    );
END divider_srl;



ARCHITECTURE arch_divider_srl OF divider_srl IS

  SIGNAL feedBack : std_logic;

BEGIN


  u0 : SRLC32E
  GENERIC MAP (
    INIT => X"00000001")
  PORT MAP (
    Q   => feedBack,
    Q31 => OPEN,
    A   => DIV,
    CE  => CE_IN,
    CLK => CLK,
    D   => feedBack
    );

  CE_OUT <= CE_IN AND feedBack;
  


END arch_divider_srl;
--------------------------------------------
-- END OF FILE : arch_divider_srl.vhd
--------------------------------------------



